#ifndef BOHA_BATTERY
#define BOHA_BATTERY

#include "charcolor.h"

#include <memory>

class BulletML;
class Enemy;

class Battery {
public:
	Battery(const Point& pnt, const std::string& xml);
	~Battery();

	void setDirection(double d) { dir_ = d; }
	void setTurn(int t) { turn_ = t; }
	void setColor(CharColor c) { col_ = c; }
	void setRank(double r) { rank_ = r; }
	void setIsLaser(bool l) { isLaser_ = l; }
	void setIsScroll(bool s) { isScroll_ = s; }
	void setWidth(int w) { width_ = w; }
	void setInvisible(int i) { invisible_ = i; }
	void setChildColor(CharColor c) { childColor_ = c; }

	void event();

private:
	Point pnt_;
	double dir_;
	int turn_;
	CharColor col_;
	double rank_;
	bool isLaser_;
	bool isScroll_;
	int width_;

	std::auto_ptr<BulletML> bulletml_;

	Enemy* enemy_;

	bool alive_;

	int invisible_;
	CharColor childColor_;

	double dirPrev_;

};

#endif // ! BOHA_BATTERY
