#include "bulletml.h"
#include "util.h"
#include "enemy.h"

#include <vector>
#include <algorithm>
#include <functional>
#include <string>

BulletML::BulletML()
    : bulletml_(0), isHorizontal_(false)
{}

BulletML::~BulletML() {
    // XMLNode ϥ롼ȥΡɤ˲ɤ
    delete bulletml_;
}

bool BulletML::haveActionRef(const std::string& key) {
    return actionMap_.find(key) != actionMap_.end();
}

XMLNode* BulletML::getBulletRef(const std::string& key) {
    BulletMap::const_iterator ite = bulletMap_.find(key);
    ASSERT(ite != bulletMap_.end(),
	   "bulletRef key " + key + " doesn't exist.");
    return ite->second;
}

XMLNode* BulletML::getActionRef(const std::string& key) {
    ActionMap::const_iterator ite = actionMap_.find(key);
    ASSERT(ite != actionMap_.end(),
	   "actionRef key " + key + " doesn't exist.");
    return ite->second;
}

XMLNode* BulletML::getFireRef(const std::string& key) {
    FireMap::const_iterator ite = fireMap_.find(key);
    ASSERT(ite != fireMap_.end(),
	   "fireRef key " + key + " doesn't exist.");
    return ite->second;
}

XMLNode* BulletML::addContent(const std::string& name) {
    // 롼ȥΡɤ̽
    if (name == "bulletml") {
	bulletml_ = new XMLNode(name);
	return bulletml_;
    }
    ASSERT(bulletml_ != 0, "<bulletml> doesn't come.");

    return new XMLNode(name);
}

void BulletML::addAttribute(const MyAttributes& attr, XMLNode* elem) {
    if (!attr.empty()) {
        MyAttributeIte ite = attr.begin();
        while (ite != attr.end()) {
            const std::string key(*ite);
            ite++;
            const std::string val(*ite);
            ite++;
            elem->addAttribute(key, val);
        }
    }
}

void BulletML::checkNode(XMLNode* elem) {
    // horizontal ɤ
    if (elem->getName() == "bulletml" &&
        elem->haveAttribute("type") &&
        elem->getAttribute("type") == "horizontal") {
        isHorizontal_ = true;
    }

    // ٥äƤΤ
    if (elem->haveAttribute("label")) {
        const std::string& val = elem->getAttribute("label");

        if (elem->getName() == "bullet") bulletMap_[val] = elem;
        else if (elem->getName() == "action") actionMap_[val] = elem;
        else if (elem->getName() == "fire") fireMap_[val] = elem;
    }
}


