#include "char.h"
#include "game.h"
#include "conf.h"

#include <cmath>
#include <iostream>

void Charactor::wallEvent() {
	if (zako_) {
		const Point& ms = surface_->size();

/*
		static const int margin = 10;
		if (center().x > ms.x+margin || center().x < -margin ||
			 center().y > ms.y+margin || center().y < -margin)
*/
		if ((center().x > ms.x && spd_.xd() > 0) ||
			(center().x < 0 && spd_.xd() < 0) ||
			(center().y > ms.y) ||
			(center().y < 0))
		{
			alive_ = false;
		}
	}
}

Charactor::Charactor (const Point& pnt, Window* graph, CharColor col)
	: spd_(Point(0, 0)),
	  graph_(graph), alive_(true), surface_(Game::instance()->window()),
	  col_(col), blink_(false), count_(0)
{
	// Ŭ
	if (graph_ != 0) {
		pnt_ = pnt - halfSize();
		cen_ = pnt;
	}
}

Charactor::~Charactor() {
}

bool Charactor::isHit(const Charactor* bc) const {
	// ä˲
	Point diff(cen_ - bc->center());
	return diff.xi() < 20 && diff.yi() < 20;
}

void Charactor::moveValue() {
	// 졼ϥ졼ˤǤ
	if (!isLaser()) {
		pnt_ += spd_;
		calcCenter();
	}
	else {
		Enemy* enemy = dynamic_cast<Enemy*>(this);
		if (enemy != 0) {
			pnt_ += spd_;
			calcCenter();
			enemy->updateLaser();
		}
	}
}

void Charactor::moveGraphic() const {
	if (blink_ && Game::instance()->turn() % 10 < 5) return;

	const Point& ms = surface_->size();

	if (!(center().x > ms.x || center().x < 0 ||
		  center().y > ms.y || center().y < 0)) {
		surface_->blit(graph_, pnt_);
	}
}

