#ifndef BOHA_CHAR
#define BOHA_CHAR

#include "util.h"
#include "win.h"
#include "charcolor.h"

#include <memory>

class Player;
class Enemy;
class Shot;

class Charactor {
public:
    // ֥ǥѥå
    virtual void hit (Charactor* bc) = 0;
    virtual void hitByPlayer (Player* bc) = 0;
    virtual void hitByEnemy (Enemy* bc) = 0;
    virtual void hitByShot (Shot* bc) = 0;

    bool isHit(const Charactor* bc) const;

    virtual void wallEvent();

    Charactor(const Point& pnt, Window* graph, CharColor col);
    virtual ~Charactor();

    const Point& pnt() const { return pnt_; }
	virtual void setPnt(const Point& pnt) { pnt_ = pnt; calcCenter(); }
    const Point& spd() const { return spd_; }
	virtual void setSpd(const Point& spd) { spd_ = spd; }
    virtual const Point& size() { return graph_->size(); }
    virtual const Point& halfSize() { return graph_->halfSize(); }

    const bool alive() const { return alive_; }
	virtual void die() { alive_ = false; }

    const Point& center() const {
		return cen_;
    }

    virtual void moveValue();
    virtual void moveGraphic () const;

	CharColor color() const { return col_; }

	bool isZako() const { return zako_; }
	virtual bool isLaser() const { return false; }
	virtual int width() const { return width_; }

	void countUp() { count_++; }
	int count() const { return count_; }

protected:
	void calcCenter() { cen_ = pnt_ + halfSize(); }

protected:
    Point pnt_, spd_;
	Point cen_;

	Window* graph_;
    bool alive_;

    Uint8 prevSpace_;

    Window* surface_;

    // ̤ФäΤ
    bool zako_;

	CharColor col_;

	bool blink_;

	int width_;

	int count_;

};

#endif // BOHA_CHAR

