#ifndef BOHA_GAME
#define BOHA_GAME

#include "singleton.h"
#include "mysdl_padinput.h"
#include "enemy.h"
#include "charcolor.h"
#include "mysdl_joystick.h"

#include <list>
#include <vector>
#include <queue>
#include <sstream>

#include <SDL.h>

#include <boost/smart_ptr.hpp>

class Timer;
class MainWindow;
class Charactor;
class Player;
class Enemy;
class Shot;
class NarihiraML;
class Scroll;

// 󥰥ȥ
class Game : public Singleton<Game> {
public:
    Game();

    // 餬֤ä齪λ
    int title();
    void init();
    void reinit();
    int start();

    double fps() const;
    int turn() const;

    int shotNum() const { return shot_.size(); }

    ~Game();

    Player* player() const { return player_.get(); }

	void addEnemy(boost::shared_ptr<Enemy> enemy);
	void addShot(boost::shared_ptr<Shot> shot);

    bool isStart() const { return start_; }
    bool isEnd() const { return end_; }
    void end() { end_ = true; }

    void getEnemyPosAndSpd(std::vector<std::pair<Point, Point> >& out,
						   CharColor color) const;

	void setPass() { pass_ = true; }
	bool pass() const { return pass_; }

	double getRank() const { return rank_; }

	MainWindow* window() { return window_; }

	const Scroll* scroll() const;

	const std::string bulletDir() const { return bulletDir_; }

	void eraseAllBullets();

	int waitAnyInput();
	void waitInputRelease();

public:
	void endEv();

private:
    void timerEv();
    void playerEv();
    void enemyEv();
    void shotEv();
    void hitEv();
    void updateWindow();
    void clearWindow();
    void deadEv();

private:
    MainWindow* window_;

    boost::shared_ptr<Player> player_;

	// ι¤ϤˤͤФʤޤ
	typedef std::list<boost::shared_ptr<Charactor> > Chars;
	typedef std::list<boost::shared_ptr<Enemy> > Enemys;
	typedef std::list<boost::shared_ptr<Shot> > Shots;
    Enemys enemy_;
    Shots shot_;
    Chars chars_;

    bool start_;
    bool end_;
	bool quit_;

    std::auto_ptr<MSDL::Input> inputMgr_;

    BulletML* bulletml_;

	std::auto_ptr<Timer> timer_;
	bool pass_;

	double rank_;

	std::auto_ptr<NarihiraML> narihira_;

	std::string bulletDir_;

};

#endif // BOHA_GAME
