#include "graphics.h"
#include "win.h"

Color Graphics::trans_(0xff, 0, 0xff);

Graphics::Graphics() {
	enemyBoss_[WHITE].reset(generateGraphic("bmp/ball_g.bmp"));
	enemyZako_[WHITE].reset(generateGraphic("bmp/ball_wg.bmp"));
	enemyBullet_[WHITE].reset(generateGraphic("bmp/ball_wr.bmp"));
	enemyBoss_[BLACK].reset(generateGraphic("bmp/ball_gb.bmp"));
	enemyZako_[BLACK].reset(generateGraphic("bmp/ball_bg.bmp"));
	enemyBullet_[BLACK].reset(generateGraphic("bmp/ball_br.bmp"));
	enemyBoss_[EMPTY].reset(generateGraphic("bmp/ball_gr.bmp"));
	enemyZako_[EMPTY].reset(generateGraphic("bmp/ball_gr.bmp"));
	enemyBullet_[EMPTY].reset(generateGraphic("bmp/ball_gr.bmp"));
	shot_[WHITE].reset(generateGraphic("bmp/ball_w.bmp"));
	shot_[BLACK].reset(generateGraphic("bmp/ball_b.bmp"));
}

Window* Graphics::enemyBoss(CharColor col) {
	return enemyBoss_[col].get();
}

Window* Graphics::enemyZako(CharColor col) {
	return enemyZako_[col].get();
}

Window* Graphics::enemyBullet(CharColor col) {
	return enemyBullet_[col].get();
}

Window* Graphics::shot(CharColor col) {
	return shot_[col].get();
}

Window* Graphics::generateGraphic(const std::string& filename) {
	Window* ret = new Window(filename);
	ret->setColorKey(SDL_SRCCOLORKEY, trans_);
	ret->convertDisplayFormat();
	return ret;
}

