#ifndef BOHA_GRAPHICS
#define BOHA_GRAPHICS

#include "singleton.h"
#include "charcolor.h"
#include "util.h"

#include <memory>
#include <string>

class Window;

class Graphics : public Singleton<Graphics> {
public:
	Graphics();

	Window* enemyBoss(CharColor col);
	Window* enemyZako(CharColor col);
	Window* enemyBullet(CharColor col);
	Window* shot(CharColor col);

private:
	Window* generateGraphic(const std::string& filename);

private:
	std::auto_ptr<Window> enemyBoss_[3], enemyZako_[3], enemyBullet_[3];
    std::auto_ptr<Window> shot_[2];

private:
	static Color trans_;

};

#endif // ! BOHA_GRAPHICS
