/// 祤ƥåʤ
/**
 * Ūˤå
 * 祤ƥåƤ뤫ʤ򵤤ˤ˻Ȥ
 */

#ifndef __MYSDL_JOYSTICK_H__
#define __MYSDL_JOYSTICK_H__

#include "mysdl_error.h"

#include <vector>
#include <iostream>

#include <singleton.h>
#include <builtinfuncs.h>

#include <SDL.h>

namespace MSDL {

class Joystick {
public:
	explicit Joystick(int index) {
		_joystick = SDL_JoystickOpen(index);
		if (_joystick != 0) std::cout << "success open joystick " <<
								index << std::endl;
		else std::cout << "failed open joystick " << index << std::endl;
	}
	~Joystick() {
		if (isInited()) SDL_JoystickClose(_joystick);
	}

	bool isInited() const { return _joystick != 0; }

	Sint16 axis(int axis) const {
		return SDL_JoystickGetAxis(const_cast<SDL_Joystick*>(_joystick), axis);
	}
	Sint16 axisX() const {
		return axis(0);
	}
	Sint16 axisY() const {
		return axis(1);
	}

	Uint8 getButton(int button) const {
		return 1 == SDL_JoystickGetButton(const_cast<SDL_Joystick*>(_joystick),
										  button);
	}

private:
	SDL_Joystick* _joystick;

};

class JoystickMgr : public Singleton<JoystickMgr> {
public:
	/**
	 * @return
	 * 顼ξ 0 ֤
	 * ϡJoystick  open ǤʤȤ뤫Ȼפ
	 */
	Joystick* getJoystick(int index) {
		checkInit();

		if (!_inited) return 0;

		checkJoysticksSize(index);

		if (_joysticks[index] == 0) {
			_joysticks[index] = new Joystick(index);
		}

		if (_joysticks[index]->isInited()) {
			return _joysticks[index];
		}
		else {
			return 0;
		}
	}

	~JoystickMgr() {
		deleteClear(_joysticks);
	}

private:
	void checkJoysticksSize(unsigned int index) {
		if (_joysticks.size() <= index) {
			_joysticks.resize(index+1, 0);
		}
	}

	void checkInit() {
		_inited = true;
		if (!SDL_WasInit(SDL_INIT_JOYSTICK)) {
			SDL_InitSubSystem(SDL_INIT_JOYSTICK);
			std::cout << "joystick inited." << std::endl;
		}
	}

private:
	bool _inited;
	std::vector<Joystick*> _joysticks;

};

}

#endif // ! __MYSDL_JOYSTICK_H__
