/// NarihiraML 饹
/**
 * BulletML Ȥϰä TinyXML 򤽤Τޤ޻Ȥ
 * BulletML ȤϰäƤΥ饹 Scroll, Obstacle, Battery 롣
 */

#ifndef BOHA_NARIHIRAML
#define BOHA_NARIHIRAML

#include <string>
#include <vector>
#include <memory>

class Obstacle;
class Scroll;
class Battery;
class TiXmlNode;

class NarihiraML {
public:
	explicit NarihiraML(const std::string& filename);
	~NarihiraML();

public:
	void event();

public:
	const Scroll* scroll() const { return scroll_.get(); }

private:
	void drawObstacles();
	void batteryEvent();
	void collisionObstacle();

private:
	void parseNarihira(TiXmlNode* node);
	void parseScroll(TiXmlNode* node);
	void parsePosition(TiXmlNode* node);
	void parseRoll(TiXmlNode* node);
	void parseObstacle(TiXmlNode* node);
	void parseBattery(TiXmlNode* node);

private:
	std::vector<Obstacle*> obstacles_;
	std::auto_ptr<Scroll> scroll_;
	std::vector<Battery*> batteries_;

};

#endif // ! BOHA_NARIHIRAML
