#include "obstacle.h"
#include "char.h"
#include "win.h"
#include "game.h"
#include "scroll.h"

Obstacle::Obstacle(const Point& pnt, const Point& size, bool scroll)
	: pnt_(pnt), scroll_(scroll)
{
	size_ = Point(size.xd()*172.8, size.yd()*230.4);
	halfSize_ = size_/2;
	win_ = Game::instance()->window();
}

Point Obstacle::convertedPoint() const {
	Point ret;
	if (scroll_) ret = Game::instance()->scroll()->convertPoint(pnt_);
	else ret = Game::instance()->scroll()->convertScale(pnt_);
	return ret;
}

void Obstacle::draw() const {
	win_->drawRect(Rect(convertedPoint()-halfSize_, size_, true),
				   Color::YELLOW);
}

bool Obstacle::isHit(const Charactor* ch) const {
	const Point& cen = ch->center();
	Point lp(convertedPoint()-halfSize_);
	Point up(lp+size_);
	if (cen.xi() > lp.xi() && cen.xi() < up.xi() &&
		cen.yi() > lp.yi() && cen.yi() < up.yi())
		return true;
	else
		return false;
}

