#include "player.h"
#include "enemy.h"
#include "conf.h"
#include "game.h"
#include "shot.h"

Player::Player (const Point& pnt, MSDL::Input& inputMgr, CharColor col)
	// Ȥꤢ NULL 
    : Charactor(pnt, 0, col), pow_(100), inputMgr_(inputMgr),
	  dead_(0), changeTo_(EMPTY)
{
	eat_[0] = 0;
	eat_[1] = 0;

	zako_ = false;

	colorGraph_[WHITE].reset(new Window("bmp/jiki_w.bmp"));
	colorGraph_[BLACK].reset(new Window("bmp/jiki_b.bmp"));
	colorGraph_[EMPTY].reset(new Window("bmp/jiki_e.bmp"));
	Color trans(255, 0, 255);
	colorGraph_[WHITE]->setColorKey(SDL_SRCCOLORKEY, trans);
	colorGraph_[BLACK]->setColorKey(SDL_SRCCOLORKEY, trans);
	colorGraph_[EMPTY]->setColorKey(SDL_SRCCOLORKEY, trans);

	// 
	graph_ = colorGraph_[col].get();
	setPnt(pnt - halfSize());
}

void Player::hitByPlayer (Player*) {
	assert(0);
}

void Player::hitByEnemy (Enemy* bc) {
	if (!bc->isInvisible()) nearFromShot(bc);
}

void Player::hitByShot (Shot* bc) {
	nearFromShot(bc);
}

void Player::die() {
	if (!blink_) {
		blink_ = true;
		invicibleTurn_ = Game::instance()->turn()+180;
		dead_++;
		setPnt(Point(180, 460) - size() / 2);
		Game::instance()->eraseAllBullets();
	}
}

void Player::nearFromShot(Charactor* bc) {
	if (col_ != bc->color()) {
		if (center().length(bc->center()) < 4+bc->width()/2) {
			die();
		}
	}
	else {
		if (center().length(bc->center()) < 12+bc->width()/2) {
			if (bc->isZako()) {
				if (bc->isLaser()) pnt_ += bc->spd();
				eat_[bc->color()]++;
				bc->die();
			}
		}
	}
}

void Player::event() {
	keyEvent();
	changeEvent();
	miscEvent();
}

void Player::changeEvent() {
	if (changeTo_ != EMPTY && changeTimer_ < Game::instance()->turn()) {
		col_ = changeTo_;
		graph_ = colorGraph_[col_].get();
		changeTo_ = EMPTY;
	}
}

void Player::miscEvent() {
	if (blink_ && invicibleTurn_ < Game::instance()->turn()) {
		blink_ = false;
	}
}

void Player::keyEvent() {
	Game* game = Game::instance();

	spd_ = Point(0, 0);

	SDL_PumpEvents();

	static const double baseSpeed = 3;
	double base = baseSpeed;

	double cross = base / SQRT_TWO;

	MSDL::Axis axis = inputMgr_.getAxis();

	if (axis == MSDL::Axis::UP) spd_.y = -base;
	else if (axis == MSDL::Axis::RIGHT) spd_.x = base;
	else if (axis == MSDL::Axis::DOWN) spd_.y = base;
	else if (axis == MSDL::Axis::LEFT) spd_.x = -base;
	else if (axis == MSDL::Axis::UPRIGHT) {
		spd_.x = cross;
		spd_.y = -cross;
	}
	else if (axis == MSDL::Axis::DOWNRIGHT) {
		spd_.x = cross;
		spd_.y = cross;
	}
	else if (axis == MSDL::Axis::DOWNLEFT) {
		spd_.x = -cross;
		spd_.y = cross;
	}
	else if (axis == MSDL::Axis::UPLEFT) {
		spd_.x = -cross;
		spd_.y = -cross;
	}

	if (inputMgr_.getButton(3)) game->end();

	if (inputMgr_.getButton(1) && changeTo_ == EMPTY) {
		changeTimer_ = Game::instance()->turn() + 15;
		changeTo_ = col_.reverse();
		graph_ = colorGraph_[EMPTY].get();
		col_ = EMPTY;
	}

}

Player::~Player() {}

void Player::wallEvent() {
	static const Point& ms = surface_->size();
	static const Point& cs = graph_->size();
	static const Point upper(ms.x-cs.x, ms.y-cs.y);

	if (pnt_.x > upper.x) pnt_.x = upper.x;
	else if (pnt_.x < 0) pnt_.x = 0;
	if (pnt_.y > upper.y) pnt_.y = upper.y;
	else if (pnt_.y < 0) pnt_.y = 0;
}
