#ifndef BOHA_PLAYER
#define BOHA_PLAYER

#include "char.h"
#include "mysdl_padinput.h"

class CpuInput;
class Window;

class Player : public Charactor {
public:
    Player (const Point& pnt, MSDL::Input& inputMgr, CharColor col);
    virtual ~Player();

    virtual void hit (Charactor* bc) { bc->hitByPlayer(this); }
    virtual void hitByPlayer (Player* bc);
    virtual void hitByEnemy (Enemy* bc);
    virtual void hitByShot (Shot* bc);

    Point upperPoint() const {
		return surface_->size() - graph_->size();
    }

	void event();

	virtual void wallEvent();

	virtual void die();

	int eat(CharColor col) const { return eat_[col]; }
	int dead() const { return dead_; }

private:
    void keyEvent ();
	void changeEvent();
	void miscEvent();

private:
	void nearFromShot(Charactor* bc);

private:
	std::auto_ptr<Window> colorGraph_[3];

private:
    double prevShotTurn_;

    double pow_;

    MSDL::Input& inputMgr_;

	int eat_[2];
	int dead_;

	int changeTimer_;
	CharColor changeTo_;

	int invicibleTurn_;

};

#endif // ! BOHA_PLAYER
