#ifndef BOHA_SCROLL
#define BOHA_SCROLL

#include "util.h"

#include <vector>

class Scroll {
public:
	Scroll() : endTurn_(0) {}

	void setPosition(double x, double y, int t);
	void setRoll(double d, int t);

	Point convertPoint(const Point& pnt) const;
	Point convertScale(const Point& pnt) const;
	double convertDir(double r) const;

	bool isEnd() const;

	bool isRoll() const { return !rolls_.empty(); }

private:
	std::vector<Point> positions_;
	std::vector<double> rolls_;

	int endTurn_;

};

#endif // ! BOHA_SCROLL
