#include "select.h"
#include "win.h"
#include "util.h"
#include "game.h"

#include <vector>
#include <fstream>

Select::Select(MSDL::Input* input)
	: input_(input)
{
	win_ = Game::instance()->window();
}

int Select::selectBullet() {
	std::vector<std::string> bullets;
	std::ifstream is("bullets.conf");
	std::copy(std::istream_iterator<std::string>(is),
			  std::istream_iterator<std::string>(),
			  std::back_inserter(bullets));

	for (unsigned int i = 0; i < bullets.size(); i++) {
		putString(bullets[i], 0, i, Color::YELLOW);
	}

	int height = 0;
	int heights = bullets.size()-1;

	std::auto_ptr<MSDL::InputState> state;

	while(1) {
		putString(bullets[height], 0, height, Color::RED);

		win_->flip();
		SDL_Delay(100);
		do {
			SDL_PumpEvents();
			state.reset(new MSDL::InputState(*input_));
			Game::instance()->endEv();
			if (Game::instance()->isEnd()) return -1;
			SDL_Delay(50);
		} while (!state->getAny());

		putString(bullets[height], 0, height, Color::YELLOW);

		if (state->getAxis().isDown() && height != heights) height++;
		if (state->getAxis().isUp() && height != 0) height--;

		if (state->getButton(0) || state->getButton(1)) {
			break;
		}
		else if (state->getButton(3)) {
			return -1;
		}

	}

	bulletDir_ = bullets[height];

	win_->clear();
	Game::instance()->waitInputRelease();

	return 0;
}

void Select::putString(const std::string& str, int x, int y,
					   const Color& col) {
	win_->clearRect(Rect(x*charWidth_, y*charHeight_,
						 str.size()*charWidth_, charHeight_, true));
	win_->putString(str, Point(x*charWidth_, y*charHeight_), col);
}
