#include "shot.h"
#include "player.h"
#include "graphics.h"

Shot::Shot (const Point& pnt, const Point& spd,
			CharColor col, bool isLaser, int width, const Point& srcspd)
    : Charactor(pnt, 0, col), isLaser_(isLaser) {
	width_ = width;
	spd_ = spd;
	if (spd_.xd() == 0 && spd_.yd() == 0) gspd_ = srcspd * 16;
	else gspd_ = spd_ * 4;
	if (isLaser) gspd_ *= 2;

	zako_ = true;

	graph_ = Graphics::instance()->shot(col);
	pnt_ = pnt - halfSize();
	cen_ = pnt;

}

void Shot::hitByPlayer (Player*) {
}

void Shot::hitByEnemy (Enemy*) {
}

void Shot::hitByShot (Shot*) {
}

void Shot::moveGraphic() const {
	surface_->drawLine(pnt_, gspd_, width_, col_.color(), col_.color2());
}

void Shot::setPnt(const Point& pnt) {
	Charactor::setPnt(pnt);
	gspd_ = spd_ * 8;
}
