#ifndef BOHA_SINGLETON
#define BOHA_SINGLETON

#include "util.h"

template <class T_>
struct CannotNewPolicy {
	static T_* New() { return new T_(); }
};

template <class T_>
struct CanNewPolicy {
	static T_* New() {
		ASSERT(0, "singleton yet");
		return 0;     // not reach, but for warning
	}
};

// 󥰥ȥΥ١
template<class T_, template <class> class NewPolicy_ = CannotNewPolicy>
class Singleton {
public:
	static T_* instance() {
		if (!instance_) {
			instance_ = NewPolicy_<T_>::New();
		}
		return dynamic_cast<T_*>(instance_);
	}

	Singleton() {
		ASSERT(instance_ == 0, "Singleton is made twice.\n");
		instance_ = this;
	}

	virtual ~Singleton() {}

protected:
	static Singleton* instance_;
};

template<class T_, template <class> class NewPolicy_>
Singleton<T_, NewPolicy_>* Singleton<T_, NewPolicy_>::instance_ =0;

#endif // ! BOHA_SINGLETON
