#include "timer.h"
#include "game.h"

const int Timer::idealFps_ = 60;
const int Timer::ticksPerFrame_ = 1000 / idealFps_;

Timer::Timer()
	: prevTicks_(0), turn_(0), frames_(0)
{
	startTicks_ = ticks_ = SDL_GetTicks();

	fps_ = 60;
}

Timer::~Timer() {
	std::cout << getTrueFps() << " is true frame per second." << std::endl;
}

void Timer::infoEvent() {
    Uint32 ticks = getEllapsed();
	if (ticks != prevTicks_) {
		prevTicks_ = ticks;
	}
}

void Timer::waitEvent() {
	ticks_ += ticksPerFrame_;
    Uint32 now = SDL_GetTicks();

    if (ticks_ > now) {
		SDL_Delay(ticks_ - now);
		frames_++;
    }
    else {
		Game::instance()->setPass();
    }
    turn_++;

}

double Timer::getTrueFps() const {
	Uint32 ticks = SDL_GetTicks() - startTicks_;
	return (ticks == 0) ? 0 : frames_ * 1000 / ticks;
}

