#ifndef BOHA_TIMER
#define BOHA_TIMER

#include <SDL.h>

class Timer {
public:
	/// 򳫻ϻȤߤʤȤ
	Timer();
	~Timer();

	void infoEvent();
	void waitEvent();

	Uint32 ticks() const { return ticks_; }
	int getEllapsed() const { return ticks_ - startTicks_; }
	int turn() const { return turn_; }
	int fps() const { return fps_; }
	void reset() { startTicks_ = ticks_ = SDL_GetTicks(); }

	double getTrueFps() const;
	int getMin() const {
		return getEllapsed()/60000;
	}
	int getSec() const {
		return (getEllapsed()-getMin()*60000)/1000;
	}
	int getTick() const {
		return (getEllapsed()-getMin()*60000-getSec()*1000)/10;
	}

private:
    static const int idealFps_;
    static const int ticksPerFrame_;

private:
    Uint32 startTicks_, ticks_, prevTicks_;
	int turn_;
	int fps_;
	int frames_;
};

#endif // ! BOHA_TIMER

