/// xmlĥ꡼

#ifndef BOHA_XMLTREE
#define BOHA_XMLTREE

#include <map>
#include <string>
#include <algorithm>

#include "tree.h"

class XMLNode : public TreeNode<XMLNode> {
public:
    typedef TreeNode<XMLNode>::Children Children;
    typedef TreeNode<XMLNode>::ChildIterator ChildIterator;

public:
    XMLNode(const std::string& name);
    virtual ~XMLNode();

    void setName(const std::string& name) { name_ = name; }
    const std::string& getName() const { return name_; }

    void setValue(const std::string& val) { val_ = val; }
    const std::string& getValue() const { return val_; }

    void addAttribute(const std::string& key, const std::string& val);
    bool haveAttribute(const std::string& key) const;
    const std::string& getAttribute(const std::string& key) const;

    XMLNode* getChild(const std::string& name);
    template <class OutIte_>
    void getAllChildren(const std::string& name, OutIte_ outIte);

    /// ¹˻ꤷ̾˰פΤ뤫ɤ
    bool findNode(const std::string& name) const;

    XMLNode* next();

    virtual void dump();

protected:
    typedef std::map<std::string, std::string> AttributeMap;
    AttributeMap attributes_;

    std::string name_;

    std::string val_;
};

template <class OutIte_>
void XMLNode::getAllChildren(const std::string& name, OutIte_ outIte) {
    ChildIterator ite;
    for (ite = childBegin(); ite != childEnd(); ite++) {
		if ((*ite)->getName() == name) *outIte = *ite;
		outIte++;
    }
}

#endif // ! BOHA_XMLTREE
